//----------------------------------------------------------------------------
// FlexCalendar.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: FlexCalendar.pas
//----------------------------------------------------------------------------
#ifndef FlexCalendarHPP
#define FlexCalendarHPP
//----------------------------------------------------------------------------
#include <Flex.hpp>
#include <StdCtrls.hpp>
#include <Grids.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Flexcalendar
{
//-- type declarations -------------------------------------------------------
class __declspec(delphiclass) TFlexCalendar;
class __declspec(pascalimplementation) TFlexCalendar : public Grids::TCustomGrid
{
	typedef Grids::TCustomGrid inherited;
	
private:
	Graphics::TColor FHeaderColor;
	Graphics::TColor FMonthBackColor;
	Graphics::TColor FSelectedDateColor;
	Graphics::TColor FOtherMonthsBackColor;
	Graphics::TFont* FHeaderFont;
	Graphics::TFont* FMonthFont;
	Graphics::TFont* FSelectedDateFont;
	Graphics::TFont* FOtherMonthsFont;
	System::TDateTime FDate;
	bool FShowOtherMonthDays;
	bool FHighlightCurrentDate;
	Graphics::TColor FHighlightColor;
	bool FUpdating;
	int FirstDayStarts;
	Classes::TNotifyEvent FOnChange;
	Stdctrls::TLabel* FTitleLabel;
	void __fastcall Recalculate(void);
	void __fastcall SetShowOtherMonthDays(bool Value);
	virtual void __fastcall DrawCell(long ACol, long ARow, const Windows::TRect &ARect, Grids::TGridDrawState 
		AState);
	bool __fastcall IsLeapYear(int SomeYear);
	int __fastcall GetDaysInMonth(int SomeYear, int SomeMonth);
	System::TDateTime __fastcall ChangeDate(System::TDateTime SomeDate, int DeltaYear, int DeltaMonth, 
		int DeltaDay);
	void __fastcall SetDate(System::TDateTime Value);
	void __fastcall SetHeaderColor(Graphics::TColor Value);
	void __fastcall SetSelectedDateColor(Graphics::TColor Value);
	void __fastcall SetMonthBackColor(Graphics::TColor Value);
	void __fastcall SetOtherMonthsBackColor(Graphics::TColor Value);
	void __fastcall SetHeaderFont(Graphics::TFont* Value);
	void __fastcall SetSelectedDateFont(Graphics::TFont* Value);
	void __fastcall SetMonthFont(Graphics::TFont* Value);
	void __fastcall SetOtherMonthsFont(Graphics::TFont* Value);
	void __fastcall SetHighlightColor(Graphics::TColor Value);
	void __fastcall SetHighlightCurrentDate(bool Value);
	void __fastcall SetTitleLabel(Stdctrls::TLabel* Value);
	System::AnsiString __fastcall GetCellText(int ACol, int ARow);
	
protected:
	virtual void __fastcall Click(void);
	virtual bool __fastcall SelectCell(long ACol, long ARow);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TFlexCalendar(Classes::TComponent* AOwner);
	__property System::AnsiString CellText[int ACol][int ARow] = {read=GetCellText};
	__fastcall virtual ~TFlexCalendar(void);
	void __fastcall MoveDate(int DeltaYear, int DeltaMonth, int DeltaDay);
	void __fastcall GoToToday(void);
	void __fastcall PrevMonth(void);
	void __fastcall NextMonth(void);
	void __fastcall PrevYear(void);
	void __fastcall NextYear(void);
	
__published:
	__property Graphics::TFont* HeaderFont = {read=FHeaderFont, write=SetHeaderFont, nodefault};
	__property Graphics::TFont* MonthFont = {read=FMonthFont, write=SetMonthFont, nodefault};
	__property Graphics::TFont* SelectedDateFont = {read=FSelectedDateFont, write=SetSelectedDateFont, 
		nodefault};
	__property Graphics::TFont* OtherMonthsFont = {read=FOtherMonthsFont, write=SetOtherMonthsFont, nodefault
		};
	__property Graphics::TColor HeaderColor = {read=FHeaderColor, write=SetHeaderColor, nodefault};
	__property Graphics::TColor MonthBackColor = {read=FMonthBackColor, write=SetMonthBackColor, nodefault
		};
	__property Graphics::TColor SelectedDateColor = {read=FSelectedDateColor, write=SetSelectedDateColor
		, nodefault};
	__property Graphics::TColor OtherMonthsBackColor = {read=FOtherMonthsBackColor, write=SetOtherMonthsBackColor
		, nodefault};
	__property bool HighlightCurrentDate = {read=FHighlightCurrentDate, write=SetHighlightCurrentDate, 
		nodefault};
	__property Graphics::TColor HighlightColor = {read=FHighlightColor, write=SetHighlightColor, nodefault
		};
	__property bool ShowOtherMonthDays = {read=FShowOtherMonthDays, write=SetShowOtherMonthDays, nodefault
		};
	__property System::TDateTime Date = {read=FDate, write=SetDate};
	__property Stdctrls::TLabel* TitleLabel = {read=FTitleLabel, write=SetTitleLabel, nodefault};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
public:
	/* TWinControl.CreateParented */ __fastcall TFlexCalendar(HWND ParentWindow) : Grids::TCustomGrid(ParentWindow
		) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);

}	/* namespace Flexcalendar */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Flexcalendar;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// FlexCalendar
